package main

import (
	"fmt"
	"net/http"

	"github.com/labstack/echo"
	"github.com/labstack/echo/middleware"
)

func main() {
	e := echo.New()
	e.Static("/", "/go/src/github.com/reactima/reactima-uikit/dist")
	e.GET("/app/*", func(c echo.Context) error {
		// TODO fix r
		c.Redirect(301, "/#"+c.Request().URL.Path)
		return c.String(http.StatusOK, "url"+c.Request().URL.Path)
	})

	e.Use(middleware.CORS())
	e.Use(middleware.Logger())
	e.Use(middleware.Recover())

	e.GET("/hello", getHello)
	fmt.Println("=====reactima-uikit====")
	e.Logger.Fatal(e.Start(":80"))
}

func getHello(c echo.Context) error {
	return c.String(http.StatusOK, "Hello from CRM")
}
