import React, { Component } from "react"
import cn from "classnames"
import { bindActionCreators } from "redux"
import { connect } from "react-redux"

import * as authActions from "../../actions/auth"

class HoverMenu extends Component {
  constructor(props) {
    super(props)
    this.state = {
      displayUserDropdown: false
    }
    this.timeOut = null
  }

  showUserDropdown = () => {
    if (this.timeOut) {
      clearTimeout(this.timeOut)
    }
    this.setState({ displayUserDropdown: true })
  }

  hideUserDropdown = () => {
    this.timeOut = setTimeout(() => {
      this.setState({ displayUserDropdown: false })
    }, 500)
  }

  render() {
    return (
      <div className="dropdown">
        <a
          className={
            this.props.toggleIconOff
              ? "link text-nowrap"
              : "dropdown-toggle link text-nowrap"
          }
          href="#"
          onMouseOver={this.showUserDropdown}
          onMouseOut={this.hideUserDropdown}
        >
          <span className="text-nowrap">{this.props.title}</span>
          {this.props.titleComponent}
        </a>
        <div
          className={cn(
            this.props.rightAlingOn
              ? "dropdown-menu dropdown-menu-right"
              : "dropdown-menu",
            this.state.displayUserDropdown ? "show" : "hide"
          )}
          onMouseOver={this.showUserDropdown}
          onMouseOut={this.hideUserDropdown}
        >
          {this.props.menuComponent}
        </div>

      </div>
    )
  }
}

function mapStateToProps(state) {
  return {
    token: state.auth.token
  }
}

function mapDispatchToProps(dispatch) {
  return {
    auth: bindActionCreators(authActions, dispatch)
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HoverMenu)
