import React, { Component } from "react"
import { bindActionCreators } from "redux"
import { connect } from "react-redux"

import * as authActions from "../../actions/auth"

class MobileMenu extends Component {
  constructor(props) {
    super(props)
    this.state = {
      displayUserDropdown: false
    }
    this.timeOut = null
  }

  componentDidMount() {
    // document.addEventListener('mouseover', this.showUserDropdown.bind(this))
    // document.addEventListener('mouseout', this.hideUserDropdown.bind(this))
  }

  componentWillUnmount() {
    // document.removeEventListener('mouseover', this.showUserDropdown.bind(this))
    // document.removeEventListener('mouseout', this.hideUserDropdown.bind(this))
  }

  showUserDropdown = () => {
    //console.log('showUserDropdown', this.timeOut)
    if (this.timeOut) {
      clearTimeout(this.timeOut)
    }
    this.setState({ displayUserDropdown: true })
  }

  hideUserDropdown = () => {
    ///console.log('hideUserDropdown', this.timeOut)
    this.timeOut = setTimeout(() => {
      this.setState({ displayUserDropdown: false })
    }, 500)
    // this.setState({ displayUserDropdown: false})
  }

  render() {
    return (
      <div>
        <a
          href="#"
          onMouseOver={this.showUserDropdown}
          onMouseOut={this.hideUserDropdown}
        >
          {this.props.titleComponent}
        </a>
        <div
          onMouseOver={this.showUserDropdown}
          onMouseOut={this.hideUserDropdown}
        >
          {this.props.menuComponent}
        </div>

      </div>
    )
  }
}

function mapStateToProps(state) {
  return {
    token: state.auth.token
  }
}

function mapDispatchToProps(dispatch) {
  return {
    auth: bindActionCreators(authActions, dispatch)
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(MobileMenu)
