import React, { Component } from "react"

class ReactimaFormRadio extends Component {
  static defaultProps = {
    checkedValue: "",
    onClick: () => {},
    enabled: true,
    className: ""
  }

  constructor(props) {
    super(props)
    this.state = { checkedValue: this.props.input.value }
  }

  handleClick = (e, value) => {
    e.preventDefault()
    if (this.props.enabled) {
      this.setState({ checkedValue: value })
    }
  }

  render() {
    const { input: { onChange } } = this.props
    const className = [
      this.props.className ? this.props.className : "hh-radio",
      this.state.checked ? "on" : "",
      this.props.enabled ? "" : "disabled"
    ]
      .filter(v => v.length > 0)
      .join(" ")

    return (
      <fieldset>
        <div className={className}>
          {this.props.items.map((item, i) => (
            <div className="" key={i}>
              <label
                className=""
                htmlFor={`${name}-${item.value}`}
                onClick={e => {
                  this.handleClick(e, item.value)
                  onChange(item.value)
                }}
              >
                {this.props.input.value === item.value
                  ? <i className="fa fa-dot-circle-o" />
                  : <i className="fa fa-circle-o" />}
                {item.label}
              </label>
            </div>
          ))}
        </div>
      </fieldset>
    )
  }
}

export default ReactimaFormRadio
