import React, { Component } from "react"
import Select from "./ReactimaFormSelect"

export default class ReactimaFormSelect extends Component {
  static defaultProps = {
    checked: false,
    onClick: () => {},
    enabled: true,
    className: ""
  }

  constructor(props) {
    super(props)
    this.state = { checked: this.props.checked }
  }

  handleClick = e => {
    e.preventDefault()
    if (this.props.enabled) {
      this.setState({ checked: !this.state.checked })
    }
  }

  render() {
    const {
      input: { value, checked, onChange, onBlur },
      options,
      className,
      multi
    } = this.props

    return (
      <div className={className}>
        <Select
          value={value}
          multi={multi ? true : false}
          options={options}
          onChange={value => {
            const result = multi
              ? value ? value.map(p => p.value) : null
              : value && value.value ? value.value : null
            return onChange(result)
          }}
          onBlur={() => {
            return onBlur(value)
          }}
        />
      </div>
    )
  }
}
