import React, { Component } from "react"

export default class ReactimaFormSwitch extends Component {
  static defaultProps = {
    checked: false,
    onClick: () => {},
    enabled: true,
    className: ""
  }

  constructor(props) {
    super(props)
    this.state = { checked: this.props.checked }
  }

  handleClick = e => {
    e.preventDefault()
    if (this.props.enabled) {
      this.setState({ checked: !this.state.checked })
    }
  }

  render() {
    const { input: { onChange }, text } = this.props
    const className = [
      this.props.className ? this.props.className : "hh-switch",
      this.state.checked ? "on" : "",
      this.props.enabled ? "" : "disabled"
    ]
      .filter(v => v.length > 0)
      .join(" ")

    return (
      <div>
        <div
          className={className}
          onClick={e => {
            this.handleClick(e)
            onChange(!this.state.checked)
          }}
        >
          <div className="hh-switch-toggle" />
        </div> {text}
      </div>
    )
  }
}
