import React from "react"
import ReactDOM from "react-dom"
import { Provider } from "react-redux"

import { AppContainer } from "react-hot-loader"

import configureStore from "./store/configureStore"
import "./styles/styles.scss"
import App from "./components/App"

const store = configureStore()

const render = Component => {
  ReactDOM.render(
    <AppContainer>
      <Provider store={store}>
        <Component />
      </Provider>
    </AppContainer>,
    document.getElementById("app")
  )
}

render(App)

if (module.hot) {
  module.hot.accept("./components/App", () => {
    const App = require("./components/App").default
    render(App)
  })
}
